package fhg2a;

import static repast.simphony.relogo.Utility.*;
import static repast.simphony.relogo.UtilityG.*;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import groovy.lang.Closure;
import repast.simphony.relogo.*;
import repast.simphony.relogo.builder.GeneratedByReLogoBuilder;
import repast.simphony.relogo.builder.ReLogoBuilderGeneratedFor;

@GeneratedByReLogoBuilder
@SuppressWarnings({"unused","rawtypes","unchecked"})
public class ReLogoLink<T> extends BaseLink<T>	{

	/**
	 * Returns an agentset of userTurtles on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of userTurtles on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Patch p){
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"userTurtle")){
			if (t instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of userTurtles on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Turtle t){
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"userTurtle")){
			if (tt instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of userTurtles on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.UserTurtle>();
		}

		Set<fhg2a.relogo.UserTurtle> total = new HashSet<fhg2a.relogo.UserTurtle>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(userTurtlesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(userTurtlesOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.UserTurtle>(total);
	}

	/**
	 * Queries if object is a userTurtle.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userTurtle
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public boolean isUserTurtleQ(Object o){
		return (o instanceof fhg2a.relogo.UserTurtle);
	}

	/**
	 * Returns the userTurtle with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public fhg2a.relogo.UserTurtle userTurtle(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.UserTurtle)
			return (fhg2a.relogo.UserTurtle) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all userTurtles.
	 * 
	 * @return agentset of all userTurtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtles(){
		AgentSet<fhg2a.relogo.UserTurtle> a = new AgentSet<fhg2a.relogo.UserTurtle>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.UserTurtle.class)) {
			if (e instanceof fhg2a.relogo.UserTurtle){
				a.add((fhg2a.relogo.UserTurtle)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of tribes on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of tribes on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Patch p){
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"tribe")){
			if (t instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of tribes on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of tribes on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Turtle t){
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"tribe")){
			if (tt instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of tribes on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of tribes on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.Tribe>();
		}

		Set<fhg2a.relogo.Tribe> total = new HashSet<fhg2a.relogo.Tribe>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(tribesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(tribesOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.Tribe>(total);
	}

	/**
	 * Queries if object is a tribe.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a tribe
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public boolean isTribeQ(Object o){
		return (o instanceof fhg2a.relogo.Tribe);
	}

	/**
	 * Returns the tribe with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public fhg2a.relogo.Tribe tribe(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.Tribe)
			return (fhg2a.relogo.Tribe) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all tribes.
	 * 
	 * @return agentset of all tribes
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribes(){
		AgentSet<fhg2a.relogo.Tribe> a = new AgentSet<fhg2a.relogo.Tribe>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.Tribe.class)) {
			if (e instanceof fhg2a.relogo.Tribe){
				a.add((fhg2a.relogo.Tribe)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of realisticFreeDistributions on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Patch p){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"realisticFreeDistribution")){
			if (t instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of realisticFreeDistributions on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Turtle t){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"realisticFreeDistribution")){
			if (tt instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of realisticFreeDistributions on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
		}

		Set<fhg2a.relogo.RealisticFreeDistribution> total = new HashSet<fhg2a.relogo.RealisticFreeDistribution>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(realisticFreeDistributionsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(realisticFreeDistributionsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.RealisticFreeDistribution>(total);
	}

	/**
	 * Queries if object is a realisticFreeDistribution.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a realisticFreeDistribution
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public boolean isRealisticFreeDistributionQ(Object o){
		return (o instanceof fhg2a.relogo.RealisticFreeDistribution);
	}

	/**
	 * Returns the realisticFreeDistribution with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public fhg2a.relogo.RealisticFreeDistribution realisticFreeDistribution(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.RealisticFreeDistribution)
			return (fhg2a.relogo.RealisticFreeDistribution) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all realisticFreeDistributions.
	 * 
	 * @return agentset of all realisticFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributions(){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> a = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.RealisticFreeDistribution.class)) {
			if (e instanceof fhg2a.relogo.RealisticFreeDistribution){
				a.add((fhg2a.relogo.RealisticFreeDistribution)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of idealFreeDistributions on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of idealFreeDistributions on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Patch p){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"idealFreeDistribution")){
			if (t instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of idealFreeDistributions on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of idealFreeDistributions on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Turtle t){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"idealFreeDistribution")){
			if (tt instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of idealFreeDistributions on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of idealFreeDistributions on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
		}

		Set<fhg2a.relogo.IdealFreeDistribution> total = new HashSet<fhg2a.relogo.IdealFreeDistribution>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(idealFreeDistributionsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(idealFreeDistributionsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.IdealFreeDistribution>(total);
	}

	/**
	 * Queries if object is a idealFreeDistribution.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a idealFreeDistribution
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public boolean isIdealFreeDistributionQ(Object o){
		return (o instanceof fhg2a.relogo.IdealFreeDistribution);
	}

	/**
	 * Returns the idealFreeDistribution with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public fhg2a.relogo.IdealFreeDistribution idealFreeDistribution(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.IdealFreeDistribution)
			return (fhg2a.relogo.IdealFreeDistribution) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all idealFreeDistributions.
	 * 
	 * @return agentset of all idealFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributions(){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> a = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.IdealFreeDistribution.class)) {
			if (e instanceof fhg2a.relogo.IdealFreeDistribution){
				a.add((fhg2a.relogo.IdealFreeDistribution)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of hunterGatherers on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of hunterGatherers on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Patch p){
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"hunterGatherer")){
			if (t instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of hunterGatherers on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of hunterGatherers on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Turtle t){
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"hunterGatherer")){
			if (tt instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of hunterGatherers on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of hunterGatherers on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.HunterGatherer>();
		}

		Set<fhg2a.relogo.HunterGatherer> total = new HashSet<fhg2a.relogo.HunterGatherer>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(hunterGatherersOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(hunterGatherersOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.HunterGatherer>(total);
	}

	/**
	 * Queries if object is a hunterGatherer.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a hunterGatherer
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public boolean isHunterGathererQ(Object o){
		return (o instanceof fhg2a.relogo.HunterGatherer);
	}

	/**
	 * Returns the hunterGatherer with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public fhg2a.relogo.HunterGatherer hunterGatherer(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.HunterGatherer)
			return (fhg2a.relogo.HunterGatherer) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all hunterGatherers.
	 * 
	 * @return agentset of all hunterGatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherers(){
		AgentSet<fhg2a.relogo.HunterGatherer> a = new AgentSet<fhg2a.relogo.HunterGatherer>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.HunterGatherer.class)) {
			if (e instanceof fhg2a.relogo.HunterGatherer){
				a.add((fhg2a.relogo.HunterGatherer)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of gatherers on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of gatherers on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Patch p){
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"gatherer")){
			if (t instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of gatherers on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of gatherers on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Turtle t){
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"gatherer")){
			if (tt instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of gatherers on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of gatherers on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.Gatherer>();
		}

		Set<fhg2a.relogo.Gatherer> total = new HashSet<fhg2a.relogo.Gatherer>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(gatherersOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(gatherersOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.Gatherer>(total);
	}

	/**
	 * Queries if object is a gatherer.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a gatherer
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public boolean isGathererQ(Object o){
		return (o instanceof fhg2a.relogo.Gatherer);
	}

	/**
	 * Returns the gatherer with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public fhg2a.relogo.Gatherer gatherer(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.Gatherer)
			return (fhg2a.relogo.Gatherer) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all gatherers.
	 * 
	 * @return agentset of all gatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherers(){
		AgentSet<fhg2a.relogo.Gatherer> a = new AgentSet<fhg2a.relogo.Gatherer>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.Gatherer.class)) {
			if (e instanceof fhg2a.relogo.Gatherer){
				a.add((fhg2a.relogo.Gatherer)e);
			}
		}
		return a;
	}

	/**
	 * Returns an agentset of displayHistograms on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of displayHistograms on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Patch p){
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"displayHistogram")){
			if (t instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of displayHistograms on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of displayHistograms on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Turtle t){
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"displayHistogram")){
			if (tt instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of displayHistograms on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of displayHistograms on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.DisplayHistogram>();
		}

		Set<fhg2a.relogo.DisplayHistogram> total = new HashSet<fhg2a.relogo.DisplayHistogram>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(displayHistogramsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(displayHistogramsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.DisplayHistogram>(total);
	}

	/**
	 * Queries if object is a displayHistogram.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a displayHistogram
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public boolean isDisplayHistogramQ(Object o){
		return (o instanceof fhg2a.relogo.DisplayHistogram);
	}

	/**
	 * Returns the displayHistogram with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public fhg2a.relogo.DisplayHistogram displayHistogram(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.DisplayHistogram)
			return (fhg2a.relogo.DisplayHistogram) turtle;
		return null;
	}

	/**
	 * Returns an agentset containing all displayHistograms.
	 * 
	 * @return agentset of all displayHistograms
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistograms(){
		AgentSet<fhg2a.relogo.DisplayHistogram> a = new AgentSet<fhg2a.relogo.DisplayHistogram>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.DisplayHistogram.class)) {
			if (e instanceof fhg2a.relogo.DisplayHistogram){
				a.add((fhg2a.relogo.DisplayHistogram)e);
			}
		}
		return a;
	}

	/**
	 * Queries if object is a userLink.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public boolean isUserLinkQ(Object o){
		return (o instanceof fhg2a.relogo.UserLink);
	}

	/**
	 * Returns an agentset containing all userLinks.
	 * 
	 * @return agentset of all userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> userLinks(){
		AgentSet<fhg2a.relogo.UserLink> a = new AgentSet<fhg2a.relogo.UserLink>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.UserLink.class)) {
			if (e instanceof fhg2a.relogo.UserLink){
				a.add((fhg2a.relogo.UserLink)e);
			}
		}
		return a;
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            an integer
	 * @param otherEnd
	 *            an integer
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink userLink(Number oneEnd, Number otherEnd) {
		return (fhg2a.relogo.UserLink)(this.getMyObserver().getNetwork("UserLink").getEdge(turtle(oneEnd),turtle(otherEnd)));
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            a turtle
	 * @param otherEnd
	 *            a turtle
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink userLink(Turtle oneEnd, Turtle otherEnd) {
		return userLink(oneEnd.getWho(), otherEnd.getWho());
	}

	/**
	 * Returns the value of the global variable numberOfTribes.
	 *
	 * @return the value of the global variable numberOfTribes
	 */
	@ReLogoBuilderGeneratedFor("global: numberOfTribes")
	public Object getNumberOfTribes(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("numberOfTribes");
	}

	/**
	 * Sets the value of the global variable numberOfTribes.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: numberOfTribes")
	public void setNumberOfTribes(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("numberOfTribes",value);
	}

	/**
	 * Returns the value of the global variable experimentChoice.
	 *
	 * @return the value of the global variable experimentChoice
	 */
	@ReLogoBuilderGeneratedFor("global: experimentChoice")
	public Object getExperimentChoice(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("experimentChoice");
	}

	/**
	 * Sets the value of the global variable experimentChoice.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: experimentChoice")
	public void setExperimentChoice(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("experimentChoice",value);
	}

	/**
	 * Returns the value of the global variable drawOption.
	 *
	 * @return the value of the global variable drawOption
	 */
	@ReLogoBuilderGeneratedFor("global: drawOption")
	public Object getDrawOption(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("drawOption");
	}

	/**
	 * Sets the value of the global variable drawOption.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: drawOption")
	public void setDrawOption(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("drawOption",value);
	}


}