package fhg2a;

import static repast.simphony.relogo.Utility.*;
import static repast.simphony.relogo.UtilityG.*;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import groovy.lang.Closure;
import repast.simphony.relogo.*;
import repast.simphony.relogo.builder.GeneratedByReLogoBuilder;
import repast.simphony.relogo.builder.ReLogoBuilderGeneratedFor;
import repast.simphony.space.SpatialException;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

@GeneratedByReLogoBuilder
@SuppressWarnings({"unused","rawtypes","unchecked"})
public class ReLogoTurtle extends BaseTurtle{

	/**
	 * Makes a number of new userTurtles and then executes a set of commands on the
	 * created userTurtles.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created userTurtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> hatchUserTurtles(int number, Closure closure) {
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"UserTurtle");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.UserTurtle){
				result.add((fhg2a.relogo.UserTurtle)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new userTurtles and then executes a set of commands on the
	 * created userTurtles.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created userTurtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> hatchUserTurtles(int number) {
		return hatchUserTurtles(number,null);
	}

	/**
	 * Returns an agentset of userTurtles from the patch of the caller.
	 * 
	 * @return agentset of userTurtles from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"userTurtle")){
			if (t instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of userTurtles on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of userTurtles at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"userTurtle")){
			if (t instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.UserTurtle>();
		}
	}

	/**
	 * Returns an agentset of userTurtles on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of userTurtles on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Patch p){
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"userTurtle")){
			if (t instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of userTurtles on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Turtle t){
		AgentSet<fhg2a.relogo.UserTurtle> result = new AgentSet<fhg2a.relogo.UserTurtle>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"userTurtle")){
			if (tt instanceof fhg2a.relogo.UserTurtle)
			result.add((fhg2a.relogo.UserTurtle)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of userTurtles on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtlesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.UserTurtle>();
		}

		Set<fhg2a.relogo.UserTurtle> total = new HashSet<fhg2a.relogo.UserTurtle>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(userTurtlesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(userTurtlesOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.UserTurtle>(total);
	}

	/**
	 * Queries if object is a userTurtle.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userTurtle
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public boolean isUserTurtleQ(Object o){
		return (o instanceof fhg2a.relogo.UserTurtle);
	}

	/**
	 * Returns an agentset containing all userTurtles.
	 * 
	 * @return agentset of all userTurtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public AgentSet<fhg2a.relogo.UserTurtle> userTurtles(){
		AgentSet<fhg2a.relogo.UserTurtle> a = new AgentSet<fhg2a.relogo.UserTurtle>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.UserTurtle.class)) {
			if (e instanceof fhg2a.relogo.UserTurtle){
				a.add((fhg2a.relogo.UserTurtle)e);
			}
		}
		return a;
	}

	/**
	 * Returns the userTurtle with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserTurtle")
	public fhg2a.relogo.UserTurtle userTurtle(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.UserTurtle)
			return (fhg2a.relogo.UserTurtle) turtle;
		return null;
	}

	/**
	 * Makes a number of new tribes and then executes a set of commands on the
	 * created tribes.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created tribes
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> hatchTribes(int number, Closure closure) {
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"Tribe");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.Tribe){
				result.add((fhg2a.relogo.Tribe)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new tribes and then executes a set of commands on the
	 * created tribes.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created tribes
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> hatchTribes(int number) {
		return hatchTribes(number,null);
	}

	/**
	 * Returns an agentset of tribes from the patch of the caller.
	 * 
	 * @return agentset of tribes from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"tribe")){
			if (t instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of tribes on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of tribes at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"tribe")){
			if (t instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.Tribe>();
		}
	}

	/**
	 * Returns an agentset of tribes on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of tribes on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Patch p){
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"tribe")){
			if (t instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of tribes on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of tribes on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Turtle t){
		AgentSet<fhg2a.relogo.Tribe> result = new AgentSet<fhg2a.relogo.Tribe>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"tribe")){
			if (tt instanceof fhg2a.relogo.Tribe)
			result.add((fhg2a.relogo.Tribe)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of tribes on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of tribes on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.Tribe>();
		}

		Set<fhg2a.relogo.Tribe> total = new HashSet<fhg2a.relogo.Tribe>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(tribesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(tribesOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.Tribe>(total);
	}

	/**
	 * Queries if object is a tribe.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a tribe
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public boolean isTribeQ(Object o){
		return (o instanceof fhg2a.relogo.Tribe);
	}

	/**
	 * Returns an agentset containing all tribes.
	 * 
	 * @return agentset of all tribes
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public AgentSet<fhg2a.relogo.Tribe> tribes(){
		AgentSet<fhg2a.relogo.Tribe> a = new AgentSet<fhg2a.relogo.Tribe>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.Tribe.class)) {
			if (e instanceof fhg2a.relogo.Tribe){
				a.add((fhg2a.relogo.Tribe)e);
			}
		}
		return a;
	}

	/**
	 * Returns the tribe with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Tribe")
	public fhg2a.relogo.Tribe tribe(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.Tribe)
			return (fhg2a.relogo.Tribe) turtle;
		return null;
	}

	/**
	 * Makes a number of new realisticFreeDistributions and then executes a set of commands on the
	 * created realisticFreeDistributions.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created realisticFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> hatchRealisticFreeDistributions(int number, Closure closure) {
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"RealisticFreeDistribution");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.RealisticFreeDistribution){
				result.add((fhg2a.relogo.RealisticFreeDistribution)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new realisticFreeDistributions and then executes a set of commands on the
	 * created realisticFreeDistributions.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created realisticFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> hatchRealisticFreeDistributions(int number) {
		return hatchRealisticFreeDistributions(number,null);
	}

	/**
	 * Returns an agentset of realisticFreeDistributions from the patch of the caller.
	 * 
	 * @return agentset of realisticFreeDistributions from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"realisticFreeDistribution")){
			if (t instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of realisticFreeDistributions on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of realisticFreeDistributions at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"realisticFreeDistribution")){
			if (t instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
		}
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of realisticFreeDistributions on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Patch p){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"realisticFreeDistribution")){
			if (t instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of realisticFreeDistributions on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Turtle t){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> result = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"realisticFreeDistribution")){
			if (tt instanceof fhg2a.relogo.RealisticFreeDistribution)
			result.add((fhg2a.relogo.RealisticFreeDistribution)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of realisticFreeDistributions on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of realisticFreeDistributions on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributionsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
		}

		Set<fhg2a.relogo.RealisticFreeDistribution> total = new HashSet<fhg2a.relogo.RealisticFreeDistribution>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(realisticFreeDistributionsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(realisticFreeDistributionsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.RealisticFreeDistribution>(total);
	}

	/**
	 * Queries if object is a realisticFreeDistribution.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a realisticFreeDistribution
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public boolean isRealisticFreeDistributionQ(Object o){
		return (o instanceof fhg2a.relogo.RealisticFreeDistribution);
	}

	/**
	 * Returns an agentset containing all realisticFreeDistributions.
	 * 
	 * @return agentset of all realisticFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public AgentSet<fhg2a.relogo.RealisticFreeDistribution> realisticFreeDistributions(){
		AgentSet<fhg2a.relogo.RealisticFreeDistribution> a = new AgentSet<fhg2a.relogo.RealisticFreeDistribution>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.RealisticFreeDistribution.class)) {
			if (e instanceof fhg2a.relogo.RealisticFreeDistribution){
				a.add((fhg2a.relogo.RealisticFreeDistribution)e);
			}
		}
		return a;
	}

	/**
	 * Returns the realisticFreeDistribution with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.RealisticFreeDistribution")
	public fhg2a.relogo.RealisticFreeDistribution realisticFreeDistribution(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.RealisticFreeDistribution)
			return (fhg2a.relogo.RealisticFreeDistribution) turtle;
		return null;
	}

	/**
	 * Makes a number of new idealFreeDistributions and then executes a set of commands on the
	 * created idealFreeDistributions.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created idealFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> hatchIdealFreeDistributions(int number, Closure closure) {
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"IdealFreeDistribution");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.IdealFreeDistribution){
				result.add((fhg2a.relogo.IdealFreeDistribution)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new idealFreeDistributions and then executes a set of commands on the
	 * created idealFreeDistributions.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created idealFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> hatchIdealFreeDistributions(int number) {
		return hatchIdealFreeDistributions(number,null);
	}

	/**
	 * Returns an agentset of idealFreeDistributions from the patch of the caller.
	 * 
	 * @return agentset of idealFreeDistributions from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"idealFreeDistribution")){
			if (t instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of idealFreeDistributions on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of idealFreeDistributions at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"idealFreeDistribution")){
			if (t instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
		}
	}

	/**
	 * Returns an agentset of idealFreeDistributions on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of idealFreeDistributions on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Patch p){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"idealFreeDistribution")){
			if (t instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of idealFreeDistributions on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of idealFreeDistributions on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Turtle t){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> result = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"idealFreeDistribution")){
			if (tt instanceof fhg2a.relogo.IdealFreeDistribution)
			result.add((fhg2a.relogo.IdealFreeDistribution)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of idealFreeDistributions on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of idealFreeDistributions on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributionsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
		}

		Set<fhg2a.relogo.IdealFreeDistribution> total = new HashSet<fhg2a.relogo.IdealFreeDistribution>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(idealFreeDistributionsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(idealFreeDistributionsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.IdealFreeDistribution>(total);
	}

	/**
	 * Queries if object is a idealFreeDistribution.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a idealFreeDistribution
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public boolean isIdealFreeDistributionQ(Object o){
		return (o instanceof fhg2a.relogo.IdealFreeDistribution);
	}

	/**
	 * Returns an agentset containing all idealFreeDistributions.
	 * 
	 * @return agentset of all idealFreeDistributions
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public AgentSet<fhg2a.relogo.IdealFreeDistribution> idealFreeDistributions(){
		AgentSet<fhg2a.relogo.IdealFreeDistribution> a = new AgentSet<fhg2a.relogo.IdealFreeDistribution>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.IdealFreeDistribution.class)) {
			if (e instanceof fhg2a.relogo.IdealFreeDistribution){
				a.add((fhg2a.relogo.IdealFreeDistribution)e);
			}
		}
		return a;
	}

	/**
	 * Returns the idealFreeDistribution with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.IdealFreeDistribution")
	public fhg2a.relogo.IdealFreeDistribution idealFreeDistribution(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.IdealFreeDistribution)
			return (fhg2a.relogo.IdealFreeDistribution) turtle;
		return null;
	}

	/**
	 * Makes a number of new hunterGatherers and then executes a set of commands on the
	 * created hunterGatherers.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created hunterGatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hatchHunterGatherers(int number, Closure closure) {
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"HunterGatherer");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.HunterGatherer){
				result.add((fhg2a.relogo.HunterGatherer)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new hunterGatherers and then executes a set of commands on the
	 * created hunterGatherers.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created hunterGatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hatchHunterGatherers(int number) {
		return hatchHunterGatherers(number,null);
	}

	/**
	 * Returns an agentset of hunterGatherers from the patch of the caller.
	 * 
	 * @return agentset of hunterGatherers from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"hunterGatherer")){
			if (t instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of hunterGatherers on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of hunterGatherers at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"hunterGatherer")){
			if (t instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.HunterGatherer>();
		}
	}

	/**
	 * Returns an agentset of hunterGatherers on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of hunterGatherers on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Patch p){
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"hunterGatherer")){
			if (t instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of hunterGatherers on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of hunterGatherers on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Turtle t){
		AgentSet<fhg2a.relogo.HunterGatherer> result = new AgentSet<fhg2a.relogo.HunterGatherer>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"hunterGatherer")){
			if (tt instanceof fhg2a.relogo.HunterGatherer)
			result.add((fhg2a.relogo.HunterGatherer)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of hunterGatherers on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of hunterGatherers on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherersOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.HunterGatherer>();
		}

		Set<fhg2a.relogo.HunterGatherer> total = new HashSet<fhg2a.relogo.HunterGatherer>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(hunterGatherersOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(hunterGatherersOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.HunterGatherer>(total);
	}

	/**
	 * Queries if object is a hunterGatherer.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a hunterGatherer
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public boolean isHunterGathererQ(Object o){
		return (o instanceof fhg2a.relogo.HunterGatherer);
	}

	/**
	 * Returns an agentset containing all hunterGatherers.
	 * 
	 * @return agentset of all hunterGatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public AgentSet<fhg2a.relogo.HunterGatherer> hunterGatherers(){
		AgentSet<fhg2a.relogo.HunterGatherer> a = new AgentSet<fhg2a.relogo.HunterGatherer>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.HunterGatherer.class)) {
			if (e instanceof fhg2a.relogo.HunterGatherer){
				a.add((fhg2a.relogo.HunterGatherer)e);
			}
		}
		return a;
	}

	/**
	 * Returns the hunterGatherer with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.HunterGatherer")
	public fhg2a.relogo.HunterGatherer hunterGatherer(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.HunterGatherer)
			return (fhg2a.relogo.HunterGatherer) turtle;
		return null;
	}

	/**
	 * Makes a number of new gatherers and then executes a set of commands on the
	 * created gatherers.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created gatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> hatchGatherers(int number, Closure closure) {
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"Gatherer");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.Gatherer){
				result.add((fhg2a.relogo.Gatherer)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new gatherers and then executes a set of commands on the
	 * created gatherers.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created gatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> hatchGatherers(int number) {
		return hatchGatherers(number,null);
	}

	/**
	 * Returns an agentset of gatherers from the patch of the caller.
	 * 
	 * @return agentset of gatherers from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"gatherer")){
			if (t instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of gatherers on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of gatherers at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"gatherer")){
			if (t instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.Gatherer>();
		}
	}

	/**
	 * Returns an agentset of gatherers on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of gatherers on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Patch p){
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"gatherer")){
			if (t instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of gatherers on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of gatherers on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Turtle t){
		AgentSet<fhg2a.relogo.Gatherer> result = new AgentSet<fhg2a.relogo.Gatherer>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"gatherer")){
			if (tt instanceof fhg2a.relogo.Gatherer)
			result.add((fhg2a.relogo.Gatherer)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of gatherers on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of gatherers on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherersOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.Gatherer>();
		}

		Set<fhg2a.relogo.Gatherer> total = new HashSet<fhg2a.relogo.Gatherer>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(gatherersOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(gatherersOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.Gatherer>(total);
	}

	/**
	 * Queries if object is a gatherer.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a gatherer
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public boolean isGathererQ(Object o){
		return (o instanceof fhg2a.relogo.Gatherer);
	}

	/**
	 * Returns an agentset containing all gatherers.
	 * 
	 * @return agentset of all gatherers
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public AgentSet<fhg2a.relogo.Gatherer> gatherers(){
		AgentSet<fhg2a.relogo.Gatherer> a = new AgentSet<fhg2a.relogo.Gatherer>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.Gatherer.class)) {
			if (e instanceof fhg2a.relogo.Gatherer){
				a.add((fhg2a.relogo.Gatherer)e);
			}
		}
		return a;
	}

	/**
	 * Returns the gatherer with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.Gatherer")
	public fhg2a.relogo.Gatherer gatherer(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.Gatherer)
			return (fhg2a.relogo.Gatherer) turtle;
		return null;
	}

	/**
	 * Makes a number of new displayHistograms and then executes a set of commands on the
	 * created displayHistograms.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created displayHistograms
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> hatchDisplayHistograms(int number, Closure closure) {
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"DisplayHistogram");
		for (Turtle t : createResult){
			if (t instanceof fhg2a.relogo.DisplayHistogram){
				result.add((fhg2a.relogo.DisplayHistogram)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new displayHistograms and then executes a set of commands on the
	 * created displayHistograms.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created displayHistograms
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> hatchDisplayHistograms(int number) {
		return hatchDisplayHistograms(number,null);
	}

	/**
	 * Returns an agentset of displayHistograms from the patch of the caller.
	 * 
	 * @return agentset of displayHistograms from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"displayHistogram")){
			if (t instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of displayHistograms on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of displayHistograms at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"displayHistogram")){
			if (t instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<fhg2a.relogo.DisplayHistogram>();
		}
	}

	/**
	 * Returns an agentset of displayHistograms on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of displayHistograms on patch p
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Patch p){
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"displayHistogram")){
			if (t instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of displayHistograms on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of displayHistograms on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Turtle t){
		AgentSet<fhg2a.relogo.DisplayHistogram> result = new AgentSet<fhg2a.relogo.DisplayHistogram>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"displayHistogram")){
			if (tt instanceof fhg2a.relogo.DisplayHistogram)
			result.add((fhg2a.relogo.DisplayHistogram)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of displayHistograms on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of displayHistograms on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistogramsOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<fhg2a.relogo.DisplayHistogram>();
		}

		Set<fhg2a.relogo.DisplayHistogram> total = new HashSet<fhg2a.relogo.DisplayHistogram>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(displayHistogramsOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(displayHistogramsOn(p));
				}
			}
		}
		return new AgentSet<fhg2a.relogo.DisplayHistogram>(total);
	}

	/**
	 * Queries if object is a displayHistogram.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a displayHistogram
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public boolean isDisplayHistogramQ(Object o){
		return (o instanceof fhg2a.relogo.DisplayHistogram);
	}

	/**
	 * Returns an agentset containing all displayHistograms.
	 * 
	 * @return agentset of all displayHistograms
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public AgentSet<fhg2a.relogo.DisplayHistogram> displayHistograms(){
		AgentSet<fhg2a.relogo.DisplayHistogram> a = new AgentSet<fhg2a.relogo.DisplayHistogram>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.DisplayHistogram.class)) {
			if (e instanceof fhg2a.relogo.DisplayHistogram){
				a.add((fhg2a.relogo.DisplayHistogram)e);
			}
		}
		return a;
	}

	/**
	 * Returns the displayHistogram with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.DisplayHistogram")
	public fhg2a.relogo.DisplayHistogram displayHistogram(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof fhg2a.relogo.DisplayHistogram)
			return (fhg2a.relogo.DisplayHistogram) turtle;
		return null;
	}

	/**
	 * Returns the value from the getArea() method of the underlying patch.
	 * 
	 * @return getArea() of type java.lang.Object
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public java.lang.Object getArea(){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		return p.getArea();
	}

	/**
	 * Calls the setArea(java.lang.Object) method of the underlying patch.
	 * 
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public void setArea(java.lang.Object value){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		p.setArea(value);
	}

	/**
	 * Returns the value from the getHabitat() method of the underlying patch.
	 * 
	 * @return getHabitat() of type java.lang.Object
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public java.lang.Object getHabitat(){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		return p.getHabitat();
	}

	/**
	 * Calls the setHabitat(java.lang.Object) method of the underlying patch.
	 * 
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public void setHabitat(java.lang.Object value){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		p.setHabitat(value);
	}

	/**
	 * Returns the value from the getPrey() method of the underlying patch.
	 * 
	 * @return getPrey() of type java.lang.Object
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public java.lang.Object getPrey(){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		return p.getPrey();
	}

	/**
	 * Calls the setPrey(java.lang.Object) method of the underlying patch.
	 * 
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public void setPrey(java.lang.Object value){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		p.setPrey(value);
	}

	/**
	 * Returns the value from the getWildCereal() method of the underlying patch.
	 * 
	 * @return getWildCereal() of type java.lang.Object
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public java.lang.Object getWildCereal(){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		return p.getWildCereal();
	}

	/**
	 * Calls the setWildCereal(java.lang.Object) method of the underlying patch.
	 * 
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public void setWildCereal(java.lang.Object value){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		p.setWildCereal(value);
	}

	/**
	 * Returns the value from the getFarmedCereal() method of the underlying patch.
	 * 
	 * @return getFarmedCereal() of type java.lang.Object
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public java.lang.Object getFarmedCereal(){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		return p.getFarmedCereal();
	}

	/**
	 * Calls the setFarmedCereal(java.lang.Object) method of the underlying patch.
	 * 
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserPatch")
	public void setFarmedCereal(java.lang.Object value){
		fhg2a.relogo.UserPatch p = (fhg2a.relogo.UserPatch)patchHere();
		p.setFarmedCereal(value);
	}

	/**
	 * Makes a directed userLink from a turtle to the caller then executes a set of
	 * commands on the created userLink.
	 * 
	 * @param t
	 *            a turtle
	 * @param closure
	 *            a set of commands
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink createUserLinkFrom(Turtle t, Closure closure){
		fhg2a.relogo.UserLink link = (fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(t,this);
		if (closure != null){
			this.ask(link,closure);
		}
		return link;
	}

	/**
	 * Makes a directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink createUserLinkFrom(Turtle t){
			return createUserLinkFrom(t,null);
	}

	/**
	 * Makes directed userLinks from a collection to the caller then executes a set
	 * of commands on the created userLinks.
	 * 
	 * @param a
	 *            a collection
	 * @param closure
	 *            a set of commands
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> createUserLinksFrom(Collection<? extends Turtle> a, Closure closure){
		AgentSet<fhg2a.relogo.UserLink> links = new AgentSet<fhg2a.relogo.UserLink>();
		for(Turtle t : a){
			links.add((fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(t,this));
		}
		if (closure != null){
			this.ask(links,closure);
		}
		return links;
	}

	/**
	 * Makes directed userLinks from a collection to the caller.
	 * 
	 * @param a
	 *            a collection
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> createUserLinksFrom(Collection<? extends Turtle> a){
		return createUserLinksFrom(a,null);
	}

	/**
	 * Makes a directed userLink to a turtle from the caller then executes a set of
	 * commands on the created userLink.
	 * 
	 * @param t
	 *            a turtle
	 * @param closure
	 *            a set of commands
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink createUserLinkTo(Turtle t, Closure closure){
		fhg2a.relogo.UserLink link = (fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(this,t);
		if (closure != null){
			this.ask(link,closure);
		}
		return link;
	}

	/**
	 * Makes a directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink createUserLinkTo(Turtle t){
			return createUserLinkTo(t,null);
	}

	/**
	 * Makes directed userLinks to a collection from the caller then executes a set
	 * of commands on the created userLinks.
	 * 
	 * @param a
	 *            a collection
	 * @param closure
	 *            a set of commands
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> createUserLinksTo(Collection<? extends Turtle> a, Closure closure){
		AgentSet<fhg2a.relogo.UserLink> links = new AgentSet<fhg2a.relogo.UserLink>();
		for(Object t : a){
			if (t instanceof Turtle){
				links.add((fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(this,(Turtle)t));
			}
		}
		if (closure != null){
			this.ask(links,closure);
		}
		return links;
	}

	/**
	 * Makes directed userLinks to a collection from the caller.
	 * 
	 * @param a
	 *            a collection
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> createUserLinksTo(Collection<? extends Turtle> a){
		return createUserLinksTo(a,null);
	}

	/**
	 * Queries if there is a directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return true or false based on whether there is a directed userLink from
	 *         turtle t to the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public boolean inUserLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isPredecessor(t, this);
	}

	/**
	 * Returns the agentset with directed userLinks to the caller.
	 * 
	 * @return agentset with directed userLinks to the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet inUserLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getPredecessors(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns the directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return directed userLink from turtle t to the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink inUserLinkFrom(Turtle t){
		return (fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").getEdge(t,this);
	}

	/**
	 * Returns an agentset of directed userLinks from other turtles to the caller.
	 * 
	 * @return agentset of directed userLinks from other turtles to the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> myInUserLinks(){
		AgentSet<fhg2a.relogo.UserLink> result = new AgentSet<fhg2a.relogo.UserLink>();
		for(Object o :  this.getMyObserver().getNetwork("UserLink").getInEdges(this)){
			if (o instanceof fhg2a.relogo.UserLink){
				result.add((fhg2a.relogo.UserLink) o);
			}
		}
		return result;
	}

	/**
	 * Returns an agentset of directed userLinks to other turtles from the caller.
	 * 
	 * @return agentset of directed userLinks to other turtles from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> myOutUserLinks(){
		AgentSet<fhg2a.relogo.UserLink> result = new AgentSet<fhg2a.relogo.UserLink>();
		for(Object o :  this.getMyObserver().getNetwork("UserLink").getOutEdges(this)){
			if (o instanceof fhg2a.relogo.UserLink){
				result.add((fhg2a.relogo.UserLink) o);
			}
		}
		return result;
	}

	/**
	 * Queries if there is a directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return true or false based on whether there is a directed userLink to
	 *         turtle t from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public boolean outUserLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isPredecessor(this, t);
	}

	/**
	 * Returns the agentset with directed userLinks from the caller.
	 * 
	 * @return agentset with directed userLinks from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet outUserLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getSuccessors(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns the directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return directed userLink to turtle t from the caller
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink outUserLinkTo(Turtle t){
		return (fhg2a.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").getEdge(this, t);
	}

	/**
	 * Reports true if there is a userLink connecting t and the caller.
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public boolean userLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isAdjacent(this, t);
	}

	/**
	 * Returns the agentset of all turtles found at the other end of
	 * userLinks connected to the calling turtle.
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet userLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getAdjacent(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns an agentset of the caller's userLinks.
	 * 
	 * @return agentset of the caller's userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> myUserLinks(){
		AgentSet<fhg2a.relogo.UserLink> result = new AgentSet<fhg2a.relogo.UserLink>();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getEdges(this)){
			if (o instanceof fhg2a.relogo.UserLink){
				result.add((fhg2a.relogo.UserLink)o);
			}
		}
		return result;
	}

	/**
	 * Queries if object is a userLink.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userLink
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public boolean isUserLinkQ(Object o){
		return (o instanceof fhg2a.relogo.UserLink);
	}

	/**
	 * Returns an agentset containing all userLinks.
	 * 
	 * @return agentset of all userLinks
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public AgentSet<fhg2a.relogo.UserLink> userLinks(){
		AgentSet<fhg2a.relogo.UserLink> a = new AgentSet<fhg2a.relogo.UserLink>();
		for (Object e : this.getMyObserver().getContext().getObjects(fhg2a.relogo.UserLink.class)) {
			if (e instanceof fhg2a.relogo.UserLink){
				a.add((fhg2a.relogo.UserLink)e);
			}
		}
		return a;
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            an integer
	 * @param otherEnd
	 *            an integer
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink userLink(Number oneEnd, Number otherEnd) {
		return (fhg2a.relogo.UserLink)(this.getMyObserver().getNetwork("UserLink").getEdge(turtle(oneEnd),turtle(otherEnd)));
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            a turtle
	 * @param otherEnd
	 *            a turtle
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("fhg2a.relogo.UserLink")
	public fhg2a.relogo.UserLink userLink(Turtle oneEnd, Turtle otherEnd) {
		return userLink(oneEnd.getWho(), otherEnd.getWho());
	}

	/**
	 * Returns the value of the global variable numberOfTribes.
	 *
	 * @return the value of the global variable numberOfTribes
	 */
	@ReLogoBuilderGeneratedFor("global: numberOfTribes")
	public Object getNumberOfTribes(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("numberOfTribes");
	}

	/**
	 * Sets the value of the global variable numberOfTribes.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: numberOfTribes")
	public void setNumberOfTribes(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("numberOfTribes",value);
	}

	/**
	 * Returns the value of the global variable experimentChoice.
	 *
	 * @return the value of the global variable experimentChoice
	 */
	@ReLogoBuilderGeneratedFor("global: experimentChoice")
	public Object getExperimentChoice(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("experimentChoice");
	}

	/**
	 * Sets the value of the global variable experimentChoice.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: experimentChoice")
	public void setExperimentChoice(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("experimentChoice",value);
	}

	/**
	 * Returns the value of the global variable drawOption.
	 *
	 * @return the value of the global variable drawOption
	 */
	@ReLogoBuilderGeneratedFor("global: drawOption")
	public Object getDrawOption(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("drawOption");
	}

	/**
	 * Sets the value of the global variable drawOption.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: drawOption")
	public void setDrawOption(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("drawOption",value);
	}


}