package fhg2a.relogo

import groovy.lang.MetaClass;

/**
 * Tribe that relies solely on wild cereal for sustenance,
 * and has perfect global knowledge.
 * 
 */
class Gatherer extends Tribe {

	/**
	 * Forage one year's worth of cereal. Decrease population if enough
	 * food is not gathered.
	 * 
	 */
	def forage() {

		//gather the energy required from wild cereal only
		def energyRequired = populationSize * 2000.0 * 365.0
		def gatheredEnergy = patchHere().handleWildCereal(energyRequired, populationSize)

		//cull population to size supported by the gathered energy
		cull(gatheredEnergy)
	}

	/**
	 * Move tribe to the best patch on the grid (including patch it is on).
	 * Patches are ranked by cereal density.
	 * 
	 */
	def move() {

		//calculate best patch in the world and move there
		def best = maxOneOf(patches(),{it.wildCereal.current})
		def patchNow = patchHere()
		moveTo(best)
		def patchAfter = patchHere()

		// count migration (movement to new habitat) if it took place
		if(!patchNow.habitat.equalsIgnoreCase(patchAfter.habitat)){
			migrations++
		}
	}
}
